#ifndef HELLOWORLD_HPP
#define HELLOWORLD_HPP

#include <iostream>
#include <map>
#include <string>
#include <syslog.h>
#include <cstring>

#include <boost/extension/extension.hpp>
#include <boost/extension/factory.hpp>
#include <boost/extension/type_map.hpp>

#include <plugins/plugin.hpp>

#include <ndds/ndds_cpp.h>
#include "helloworld_dds.h"
#include "helloworld_ddsSupport.h"



class helloworld : public plugin {
public:
	helloworld(DDSDomainParticipant *participant);
	void publish_information(void);
private:
	std::string get_value(void);
	DDSDomainParticipant *participant_;
	DDSPublisher *publisher_;
	DDSTopic *topic_;
	DDSDataWriter *writer_;
	helloworld_messageDataWriter * helloworld_message_writer_;
	helloworld_message *instance_;
	DDS_ReturnCode_t retcode_;
	DDS_InstanceHandle_t instance_handle_;
	const char *type_name_;
	DDS_Duration_t send_period_;
	std::string qos_file_;

};



BOOST_EXTENSION_TYPE_MAP_FUNCTION
{
	using namespace boost::extensions;
	std::map<std::string, factory<plugin, DDSDomainParticipant *> > &plugin_factories(types.get());
	plugin_factories["helloworld"].set<helloworld>();
}

#endif //HELLOWORLD_HPP


